AppDomain.FirstChanceException AppDomain.FirstChanceException AppDomain.FirstChanceException AppDomain.FirstChanceException Event

Definición

Ocurre cuando se produce una excepción en código administrado, antes de que el runtime busque un controlador de excepciones en la pila de llamadas del dominio de aplicación.Occurs when an exception is thrown in managed code, before the runtime searches the call stack for an exception handler in the application domain.

public:
 event EventHandler<System::Runtime::ExceptionServices::FirstChanceExceptionEventArgs ^> ^ FirstChanceException;
[add: System.Security.SecurityCritical]
[remove: System.Security.SecurityCritical]
public event EventHandler<System.Runtime.ExceptionServices.FirstChanceExceptionEventArgs> FirstChanceException;
member this.FirstChanceException : EventHandler<System.Runtime.ExceptionServices.FirstChanceExceptionEventArgs> 
Public Custom Event FirstChanceException As EventHandler(Of FirstChanceExceptionEventArgs) 
Atributos

Ejemplos

En el ejemplo siguiente se crea una serie de dominios AD0 de AD3aplicación denominada a Worker través de, con un objeto en cada dominio de aplicación.The following example creates a series of application domains named AD0 through AD3, with a Worker object in each application domain. Cada Worker objeto tiene una referencia Worker al objeto en el siguiente Worker dominio de aplicación, excepto en el último dominio de aplicación.Each Worker object has a reference to the Worker object in the next application domain, except for the Worker in the last application domain. El FirstChanceException evento se controla en todos los dominios de AD1aplicación excepto.The FirstChanceException event is handled in all application domains except AD1.

Nota

Además de este ejemplo, en el que se muestran las notificaciones de excepciones de primera oportunidad en varios dominios de aplicación, puede encontrar casos de uso sencillos en cómo: Recibir notificacionesde excepciones de primera oportunidad.In addition to this example, which demonstrates first-chance exception notifications in multiple application domains, you can find simple use cases in How to: Receive First-Chance Exception Notifications.

Cuando se han creado los dominios de aplicación, el dominio de aplicación predeterminado TestException llama al método para el primer dominio de aplicación.When the application domains have been created, the default application domain calls the TestException method for the first application domain. Cada Worker objeto llama al TestException método para el siguiente dominio de aplicación, hasta que Worker el último inicia una excepción que se puede controlar o no controlar.Each Worker object calls the TestException method for the next application domain, until the last Worker throws an exception that is either handled or unhandled. Por lo tanto, el subproceso actual pasa por todos los dominios TestException de aplicación y se agrega a la pila en cada dominio de aplicación.Thus, the current thread passes through all the application domains, and TestException is added to the stack in each application domain.

Cuando el último Worker objeto controla la excepción, el FirstChanceException evento solo se desencadena en el último dominio de aplicación.When the last Worker object handles the exception, the FirstChanceException event is raised only in the last application domain. Los demás dominios de aplicación nunca tienen la oportunidad de controlar la excepción, por lo que no se genera el evento.The other application domains never get a chance to handle the exception, so the event is not raised.

Cuando el último Worker objeto no controla la excepción, el FirstChanceException evento se genera en cada dominio de aplicación que tiene un controlador de eventos.When the last Worker object does not handle the exception, the FirstChanceException event is raised in each application domain that has an event handler. Una vez finalizado cada controlador de eventos, la pila continúa desenredando hasta que el dominio de aplicación predeterminado detecta la excepción.After each event handler has finished, the stack continues to unwind until the exception is caught by the default application domain.

Nota

Para ver cómo aumenta la presentación de la pila a medida que se produce el evento más cerca y más cerca del e.Exception.Message dominio e.Exception de aplicación FirstChanceHandler predeterminado, cambie a en los controladores de eventos.To see how the stack display grows as the event is raised closer and closer to the default application domain, change e.Exception.Message to e.Exception in the FirstChanceHandler event handlers. Tenga en cuenta TestException que cuando se llama a través de los límites del dominio de aplicación, aparece dos veces: una vez para el proxy y otra para el código auxiliar.Notice that when TestException is called across application domain boundaries, it appears twice: once for the proxy and once for the stub.

using System;
using System.Reflection;
using System.Runtime.ExceptionServices;

class Example
{
    static void Main()
    {
        AppDomain.CurrentDomain.FirstChanceException += FirstChanceHandler;

        // Create a set of application domains, with a Worker object in each one.
        // Each Worker object creates the next application domain.
        AppDomain ad = AppDomain.CreateDomain("AD0");
        Worker w = (Worker) ad.CreateInstanceAndUnwrap(
                                typeof(Worker).Assembly.FullName, "Worker");
        w.Initialize(0, 3);

        Console.WriteLine("\r\nThe last application domain throws an exception and catches it:");
        Console.WriteLine();
        w.TestException(true);

        try
        {
            Console.WriteLine(
                "\r\nThe last application domain throws an exception and does not catch it:");
            Console.WriteLine();
            w.TestException(false);
        }
        catch (ArgumentException ex)
        {
            Console.WriteLine("ArgumentException caught in {0}: {1}", 
                AppDomain.CurrentDomain.FriendlyName, ex.Message);
        }
    }

    static void FirstChanceHandler(object source, FirstChanceExceptionEventArgs e)
    {
        Console.WriteLine("FirstChanceException event raised in {0}: {1}",
            AppDomain.CurrentDomain.FriendlyName, e.Exception.Message);
    }
}

public class Worker : MarshalByRefObject
{
    private AppDomain ad = null;
    private Worker w = null;

    public void Initialize(int count, int max)
    {
        // Handle the FirstChanceException event in all application domains except
        // AD1.
        if (count != 1)
        {
            AppDomain.CurrentDomain.FirstChanceException += FirstChanceHandler;
        }

        // Create another application domain, until the maximum is reached.
        // Field w remains null in the last application domain, as a signal
        // to TestException(). 
        if (count < max)
        {
            int next = count + 1;
            ad = AppDomain.CreateDomain("AD" + next);
            w = (Worker) ad.CreateInstanceAndUnwrap(
                             typeof(Worker).Assembly.FullName, "Worker");
            w.Initialize(next, max);
        }
    }

    public void TestException(bool handled)
    {
        // As long as there is another application domain, call TestException() on
        // its Worker object. When the last application domain is reached, throw a
        // handled or unhandled exception.
        if (w != null)
        {
            w.TestException(handled);
        }
        else if (handled)
        {
            try
            {
                throw new ArgumentException("Thrown in " + AppDomain.CurrentDomain.FriendlyName);
            }
            catch (ArgumentException ex)
            {
                Console.WriteLine("ArgumentException caught in {0}: {1}", 
                    AppDomain.CurrentDomain.FriendlyName, ex.Message);
            }
        }
        else
        {
            throw new ArgumentException("Thrown in " + AppDomain.CurrentDomain.FriendlyName);
        }
    }

    static void FirstChanceHandler(object source, FirstChanceExceptionEventArgs e)
    {
        Console.WriteLine("FirstChanceException event raised in {0}: {1}",
            AppDomain.CurrentDomain.FriendlyName, e.Exception.Message);
    }
}

/* This example produces output similar to the following:

The last application domain throws an exception and catches it:

FirstChanceException event raised in AD3: Thrown in AD3
ArgumentException caught in AD3: Thrown in AD3

The last application domain throws an exception and does not catch it:

FirstChanceException event raised in AD3: Thrown in AD3
FirstChanceException event raised in AD2: Thrown in AD3
FirstChanceException event raised in AD0: Thrown in AD3
FirstChanceException event raised in Example.exe: Thrown in AD3
ArgumentException caught in Example.exe: Thrown in AD3
 */
Imports System.Reflection
Imports System.Runtime.ExceptionServices

Class Example

    Shared Sub Main()
    
        AddHandler AppDomain.CurrentDomain.FirstChanceException, AddressOf FirstChanceHandler

        ' Create a set of application domains, with a Worker object in each one.
        ' Each Worker object creates the next application domain.
        Dim ad As AppDomain = AppDomain.CreateDomain("AD0")
        Dim w As Worker = CType(ad.CreateInstanceAndUnwrap(
                                GetType(Worker).Assembly.FullName, "Worker"),
                                Worker)
        w.Initialize(0, 3)

        Console.WriteLine(vbCrLf & "The last application domain throws an exception and catches it:")
        Console.WriteLine()
        w.TestException(true)

        Try
            Console.WriteLine(vbCrLf & 
                "The last application domain throws an exception and does not catch it:")
            Console.WriteLine()
            w.TestException(false) 

        Catch ex As ArgumentException
        
            Console.WriteLine("ArgumentException caught in {0}: {1}", 
                AppDomain.CurrentDomain.FriendlyName, ex.Message)
        End Try
    End Sub

    Shared Sub FirstChanceHandler(ByVal source As Object, 
                                  ByVal e As FirstChanceExceptionEventArgs)
    
        Console.WriteLine("FirstChanceException event raised in {0}: {1}",
            AppDomain.CurrentDomain.FriendlyName, e.Exception.Message)
    End Sub
End Class

Public Class Worker
    Inherits MarshalByRefObject

    Private ad As AppDomain = Nothing
    Private w As Worker = Nothing

    Public Sub Initialize(ByVal count As Integer, ByVal max As Integer)
    
        ' Handle the FirstChanceException event in all application domains except
        ' AD1.
        If count <> 1
        
            AddHandler AppDomain.CurrentDomain.FirstChanceException, AddressOf FirstChanceHandler

        End If

        ' Create another application domain, until the maximum is reached.
        ' Field w remains Nothing in the last application domain, as a signal 
        ' to TestException(). 
        If count < max
            Dim nextAD As Integer = count + 1
            ad = AppDomain.CreateDomain("AD" & nextAD)
            w = CType(ad.CreateInstanceAndUnwrap(
                      GetType(Worker).Assembly.FullName, "Worker"),
                      Worker)
            w.Initialize(nextAD, max)
        End If
    End Sub

    Public Sub TestException(ByVal handled As Boolean)
    
        ' As long as there is another application domain, call TestException() on
        ' its Worker object. When the last application domain is reached, throw a
        ' handled or unhandled exception.
        If w IsNot Nothing
        
            w.TestException(handled)

        Else If handled
        
            Try
                Throw New ArgumentException("Thrown in " & AppDomain.CurrentDomain.FriendlyName)

            Catch ex As ArgumentException
            
                Console.WriteLine("ArgumentException caught in {0}: {1}", 
                    AppDomain.CurrentDomain.FriendlyName, ex.Message)
            End Try
        Else
        
            Throw New ArgumentException("Thrown in " & AppDomain.CurrentDomain.FriendlyName)
        End If
    End Sub

    Shared Sub FirstChanceHandler(ByVal source As Object, 
                                  ByVal e As FirstChanceExceptionEventArgs)
    
        Console.WriteLine("FirstChanceException event raised in {0}: {1}",
            AppDomain.CurrentDomain.FriendlyName, e.Exception.Message)
    End Sub
End Class

' This example produces output similar to the following:
'
'The last application domain throws an exception and catches it:
'
'FirstChanceException event raised in AD3: Thrown in AD3
'ArgumentException caught in AD3: Thrown in AD3
'
'The last application domain throws an exception and does not catch it:
'
'FirstChanceException event raised in AD3: Thrown in AD3
'FirstChanceException event raised in AD2: Thrown in AD3
'FirstChanceException event raised in AD0: Thrown in AD3
'FirstChanceException event raised in Example.exe: Thrown in AD3
'ArgumentException caught in Example.exe: Thrown in AD3

Comentarios

Este evento es solo una notificación.This event is only a notification. El control de este evento no controla la excepción ni afecta al control de excepciones subsiguiente de ningún modo.Handling this event does not handle the exception or affect subsequent exception handling in any way. Una vez que se ha generado el evento y se han invocado los controladores de eventos, el Common Language Runtime (CLR) comienza a buscar un controlador para la excepción.After the event has been raised and event handlers have been invoked, the common language runtime (CLR) begins to search for a handler for the exception. FirstChanceExceptionproporciona el dominio de aplicación con una primera oportunidad de examinar cualquier excepción administrada.FirstChanceException provides the application domain with a first chance to examine any managed exception.

El evento se puede controlar por dominio de aplicación.The event can be handled per application domain. Si un subproceso pasa a través de varios dominios de aplicación mientras se ejecuta una llamada, el evento se genera en cada dominio de aplicación que ha registrado un controlador de eventos, antes de que CLR empiece a buscar un controlador de excepciones coincidente en ese dominio de aplicación.If a thread passes through multiple application domains while executing a call, the event is raised in each application domain that has registered an event handler, before the CLR begins searching for a matching exception handler in that application domain. Una vez que se ha controlado el evento, se realiza una búsqueda de un controlador de excepciones coincidente en ese dominio de aplicación.After the event has been handled, a search is made for a matching exception handler in that application domain. Si no se encuentra ninguno, el evento se genera en el siguiente dominio de aplicación.If none is found, the event is raised in the next application domain.

Debe administrar todas las excepciones que se producen en el controlador de eventos FirstChanceException para el evento.You must handle all exceptions that occur in the event handler for the FirstChanceException event. De lo FirstChanceException contrario, se genera de forma recursiva.Otherwise, FirstChanceException is raised recursively. Esto podría producir un desbordamiento de pila y la terminación de la aplicación.This could result in a stack overflow and termination of the application. Se recomienda implementar controladores de eventos para este evento como regiones de ejecución restringida (CER), para que las excepciones relacionadas con la infraestructura, como la falta de memoria o el desbordamiento de la pila, afecten a la máquina virtual mientras la notificación de excepción es se está procesando.We recommend that you implement event handlers for this event as constrained execution regions (CERs), to keep infrastructure-related exceptions such as out-of-memory or stack overflow from affecting the virtual machine while the exception notification is being processed.

Este evento no se genera para excepciones que indican daños en el estado del proceso, como infracciones de acceso, a menos que el controlador de eventos sea HandleProcessCorruptedStateExceptionsAttribute crítico para la seguridad y tenga el atributo.This event is not raised for exceptions that indicate corruption of process state, such as access violations, unless the event handler is security-critical and has the HandleProcessCorruptedStateExceptionsAttribute attribute.

El Common Language Runtime suspende las anulaciones de subprocesos mientras se controla este evento de notificación.The common language runtime suspends thread aborts while this notification event is being handled.

Seguridad

SecurityCriticalAttribute
requiere plena confianza para el llamador inmediato.Requires full trust for the immediate caller. Este miembro no puede ser utilizado por código transparente o de confianza parcial.This member cannot be used by partially trusted or transparent code.

Se aplica a

Consulte también: